SystemOrganization addCategory: #'BattleShip-Control'!

Object subclass: #BattleShipConnection
	instanceVariableNames: 'myPort otherIp otherPort'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip-Control'!

!BattleShipConnection methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/7/2013 19:14'!
export: anObject named: aName 
	RSTBroker export: anObject named: aName! !

!BattleShipConnection methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/7/2013 19:16'!
get: remoteObjectName 
	^ (remoteObjectName, '@', otherIp, ':', otherPort) asRemoteObjectID asLocalObject . ! !

!BattleShipConnection methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/7/2013 18:37'!
myPort: mPort otherIp: oIp otherPort: oPort
	myPort := mPort .
	otherIp := oIp.
	otherPort := oPort .! !

!BattleShipConnection methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/7/2013 18:39'!
start
	RSTBroker startOnPort: myPort logging: true.! !

Object subclass: #GameControl
	instanceVariableNames: 'player viewController masterKey otherPlayer otherGameController connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip-Control'!

!GameControl methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/7/2013 12:03'!
beginMasterElection
	otherGameController isMaster: masterKey ifFalse: [ otherPlayer ]! !

!GameControl methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/7/2013 19:10'!
connectionSetup
	| myIp myPort otherIp otherPort |
	myPort := viewController getMyPort.
	
	otherIp := viewController getOtherIp.
	otherPort := viewController getOtherPort. 
	
	connection := BattleShipConnection new.
	connection myPort: 9999 otherIp: '127.0.1.1' otherPort: 8888.
	connection start.
	
	connection export: player named: 'player'. 
	connection export: viewController named: 'viewController'.
	connection export: self named: 'gameController'.
	
! !

!GameControl methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/7/2013 11:54'!
generateMasterKey
	masterKey := (Random seed: DateAndTime millisecondClockValue) next.! !

!GameControl methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/7/2013 11:09'!
initialize! !

!GameControl methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/7/2013 23:05'!
isMaster: otherControllerkey 
	^ masterKey > otherControllerkey ! !

!GameControl methodsFor: 'as yet unclassified' stamp: 'MihaiCodoban 5/7/2013 19:09'!
startGame
	| playerName |
	viewController := ViewController new.
	playerName := viewController getPlayerName.
	player := Player new
		gridHeight: 10
		gridWidth: 10
		name: playerName
		factory: ShipFactory new.
	
	self generateMasterKey.
	self connectionSetup.
	
	SystemWindow new openModal: AlertDialogWindow new.
	
	otherGameController := connection get: 'gameController'.
	
	Transcript open; show: otherGameController 
	
	"self beginMasterElection.
	
	self isMaster
		ifTrue: [ Transcript open; show: 'yay I am master' ]
		ifFalse: [Transcript open; show: 'awww, not master:( ' ]"! !

Object subclass: #ViewController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BattleShip-Control'!

!ViewController methodsFor: 'accessing' stamp: 'MihaiCodoban 5/7/2013 19:12'!
getMyPort
	^'bubu'! !

!ViewController methodsFor: 'accessing' stamp: 'MihaiCodoban 5/7/2013 19:13'!
getOtherIp
	^'bubu'! !

!ViewController methodsFor: 'accessing' stamp: 'MihaiCodoban 5/7/2013 19:13'!
getOtherPort
	^'bubu'! !

!ViewController methodsFor: 'accessing' stamp: 'MihaiCodoban 5/7/2013 19:12'!
getPlayerName
	^'bubu'! !
